	include "bomblib.h"	;contains the bomblib library file
				;for external save games and other things
				;including some functions for enemies and some
				;sprites
	include "doorsos.h"	;includes tios.h and some other important 
				;functions
	include "graphlib.h"	;includes the sprite routines needed for
				;this game
	include	"userlib.h"	;includes key input, boxes, and other things

	xdef    _ti89
	xdef    _comment
	xdef    _main

	include "macros.asm"		;includes macros needed for the game
	include "enemy1_proc.asm"	;many of the enemy1 procedures(others in bomblib)
	include "enemy2_proc.asm"	;many of the enemy1 procedures(others in bomblib)
	include "variables.asm"		;contains most of the immediate variables and 
					;variable resetting functions
	include "collisions.asm"	;collisions between different objects
	include "sprite_proc.asm"	;the procedures for the main player
	include "bomb_proc.asm"		;bomb procedures
	include "xexp_proc.asm"		;x explosion(+) procedures
	include "hexp_proc.asm"		;horiz. explosion(-) procedures
	include "vexp_proc.asm"		;vert. explosion(|) procedures
	include "bexp_proc.asm"		;block explosion procedures
	include "bonus_proc.asm"	;bonus procedures
	include "board.asm"		;board drawing, clearing, generation
	include "about.asm"		;about this game function
	include "options.asm"		;game options function

;*******************************************Main
;*
;*	The start of program operation
;*
;********
_main:

	SetFont #1	(MEDIUM)

	jsr	graphlib::gray4	;switches to 4 grayshades mode

	cmp.w	#0,d0
	beq	error_nogray4

	move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode

startup:

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the second bitplane

	move.w	#1,tmp
	startup_loop:

		PutGray4SpriteAL bomblib::title_pic0,bomblib::title_pic1,#0,#2
		lea		_comment(PC),a2
		lea		10(a2),a2
		SetFont #0
		WriteStrA	#140,#1,#1,a2
		SetFont #1
		WriteStr	#10,#60,#1,name_text
		WriteStr	#74,#60,#1,score_text
		WriteStr	#120,#60,#1,level_text

		move.w	#0,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#58,d1
		move.w	#160,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz
		move.w	#10,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#68,d1
		move.w	#33,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz
		move.w	#74,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#68,d1
		move.w	#103,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz
		move.w	#120,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#68,d1
		move.w	#149,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz

		WriteStr	#10,#48,#1,startup_game_text
		WriteStr	#100,#48,#1,startup_button_text
		cmp.w	#1,tmp
		beq		startup_display_new
		cmp.w	#2,tmp
		beq		startup_display_random
		cmp.w	#3,tmp
		beq		startup_display_about
		cmp.w	#4,tmp
		beq		startup_display_options
		cmp.w	#5,tmp
		beq		startup_display_load
	end_startup_display_selection:
		jsr	bomblib::score_idle_loop		;waits for a key
		cmp	#264,d0
		beq	end_main_loop
		cmp	#13,d0
		beq	end_startup_loop
		cmp	#337,d0
		beq	startup_up
		cmp	#340,d0
		beq	startup_down


		bra	end_startup_display_selection

		startup_display_new:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_new_text
			bra end_startup_display_selection

		startup_display_load:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_load_text
			bra end_startup_display_selection

		startup_display_random:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_random_text
			bra end_startup_display_selection

		startup_display_about:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_about_text
			bra end_startup_display_selection

		startup_display_options:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_options_text
			bra end_startup_display_selection

		startup_up:
			subq.w	#1,tmp
				cmp.w	#0,tmp
				bne		startup_up_no_roll
					move.w	#5,tmp
				startup_up_no_roll:

				cmp.w	#1,bomblib::saved_game
				beq		startup_up_no_check_for_saved
				cmp.w	#5,tmp
				bne		startup_up_no_check_for_saved
					move.w	#4,tmp
				startup_up_no_check_for_saved:

			bra	startup_loop

		startup_down:
			addq.w	#1,tmp
				cmp.w	#6,tmp
				bne		startup_down_no_roll
					move.w	#1,tmp
				startup_down_no_roll:

				cmp.w	#1,bomblib::saved_game
				beq		startup_down_no_check_for_saved
				cmp.w	#5,tmp
				bne		startup_down_no_check_for_saved
					move.w	#1,tmp
				startup_down_no_check_for_saved:

			bra	startup_loop

	end_startup_loop:

		cmp.w	#5,tmp
		beq		open_saved_game
		cmp.w	#4,tmp
		beq		options
		cmp.w	#3,tmp
		beq		about_game
		cmp.w	#2,tmp
		beq		begin_random_game

		Message	starting_text,round_1,#60
		bsr		idle_loop
		cmp	#264,d0
		beq	startup

		bsr		reset_game_variables

	restart_game:

		bsr	reset_variables
			cmp.w	#0,bomblib::level
			bne		restart_game_no_random
				bsr	generate_random_board
				bra		restart_game_random_end
			restart_game_no_random:

					move.w	#0,d0
					cmp.w	#4,bomblib::level
					beq		disp_round_2
					cmp.w	#7,bomblib::level
					beq		disp_round_3
					cmp.w	#10,bomblib::level
					beq		disp_round_4
					cmp.w	#13,bomblib::level
					beq		disp_round_5
					bra		end_disp_round

					disp_round_2:
						Message	starting_text,round_2,#60
						bsr		idle_loop
						bra		end_disp_round

					disp_round_3:
						Message	starting_text,round_3,#60
						bsr		idle_loop
						bra		end_disp_round

					disp_round_4:
						Message	starting_text,round_4,#60
						bsr		idle_loop
						bra		end_disp_round

					disp_round_5:
						Message	starting_text,round_5,#60
						bsr		idle_loop
						bra		end_disp_round

					end_disp_round:
						cmp	#264,d0
						beq	call_check_high_score

				bsr	generate_level_board
			restart_game_random_end:

begin_main_loop:

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the second bitplane
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the second bitplane

	move.w	#4,d0			;draw board borders
	move.w	#4,d1
	move.w	#118,d4
	move.w	#91,d5
	jsr	graphlib::frame
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::frame
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane

	move.w	#128,d0			;draw division line
	move.w	#0,d1
	move.w	#100,d2
	jsr	graphlib::vert
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::vert
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane

	PutGray4SpriteMask panel_pic,panel_pic,#%11111111,#130,#1

	bsr	draw_board		;draw game board

	bsr	draw_sprite		;draw player

	bsr	draw_life		;draw player's life

	bsr	draw_level		;draw current level

	bsr	draw_score		;draw current score

	move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode

	;bsr	disable_int1

	move.l	#5,APD_TIMER		;start the game speed equilizing timer

	bra	main_loop
end_main_loop:

	;bsr	enable_int1

	clr.w	graphlib::choosescreen	;set all graphlib functions to Black and White mode
	;jsr	userlib::idle_loop	;waits for a key
	jsr	graphlib::gray2		;restores Black and White mode

	;bsr	deallocate_tables
error_nogray4:
	rts

;*******************************************Idle Wait
;*
;*	Wait for the player to enter a key
;*
;*********
idle_loop:
         clr.w    tios::kb_vars+$1c          ; Clear keypress counter
         tst.w    tios::kb_vars+$1c          ; See if a keypress is stored
         bne.s    idle_loop                  ; Continue waiting if not
idle_loop2:
         tst.w    tios::kb_vars+$1c          ; See if a keypress is stored
         beq.s    idle_loop2                 ; Continue waiting if not
         clr.w    tios::kb_vars+$1c          ; Clear keypress counter
         move.w   tios::kb_vars+$1e,d0       ; Read keypress
idle_loop3:
         clr.w    tios::kb_vars+$1c          ; Clear keypress counter
         tst.w    tios::kb_vars+$1c          ; See if a keypress is stored
         bne.s    idle_loop3                 ; Continue waiting if not
         rts

;*******************************************Ask To Save Game
;*
;*	The player quit the game, ask them if they want to save it
;*
;*********
exit_game_ask_save:
	lea		ask_save_text,a0
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	lea		ask_save_text,a0
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	WriteStr	#50,#50,#1,ask_save_text
exit_game_ask_save_loop:
	bsr		idle_loop
	cmp.w	#110,d0
	beq		exit_game_no_save
	cmp.w	#54,d0
	beq		exit_game_no_save
	cmp.w	#121,d0
	beq		exit_game_w_save
	cmp.w	#264,d0
	beq		begin_main_loop
	bra		exit_game_ask_save_loop

exit_game_no_save:
	move.w	#0,bomblib::saved_game
	jsr	bomblib::check_high_score
	bra	end_main_loop

exit_game_w_save:
	move.w	#1,bomblib::saved_game
	bra		end_main_loop

;*******************************************Load Game
;*
;*	Doesn't do JACK, just helps us know whats going on
;*
;*********
open_saved_game:
	bra begin_main_loop

;*******************************************Begin Random Game
;*
;*	Start a randomly generated single level game
;*
;*********
begin_random_game:
	bsr		reset_game_variables
	move.w	#0,bomblib::level
	bra restart_game

;*******************************************Display Life
;*
;*	Display player's life
;*
;*********
draw_life:
	move.w	#133,d0
	move.w	#47,d1
	moveq.w	#10,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	cmp.w	#0,bomblib::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#133,#47
	cmp.w	#1,bomblib::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#139,#47
	cmp.w	#2,bomblib::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#133,#52
	cmp.w	#3,bomblib::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#139,#52
exit_draw_life:
	rts

;*******************************************Display Level
;*
;*	Display player's level
;*
;*********
draw_level:
	move.w	#133,d0
	move.w	#20,d1
	moveq.w	#10,d2
	moveq.w	#10,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	cmp.w	#0,bomblib::level
	beq		draw_level_random
	cmp.w	#10,bomblib::level
	bcc		draw_level_double
	move.w	bomblib::level,d0
	print_d0	#122,#22,#1
	rts
draw_level_random:
	WriteStr	#135,#22,#1,random_level_char
	rts
draw_level_double:
	move.w	bomblib::level,d0
	print_d0	#124,#22,#1
	rts

;*******************************************Display Score
;*
;*	Display player's score
;*
;*********
draw_score:
	cmp.w	#1000,bomblib::score
	bcs		ds_score_is_less_than_maximum
		move.w	bomblib::score,d0
		sub.w	#1000,d0
		move.w	d0,bomblib::score
		add.w	#1,bomblib::scoreh
	ds_score_is_less_than_maximum:

	move.w	bomblib::score,d0
	move.w	d0,bomblib::old_score

	move.w	#133,d0
	move.w	#95,d1
	moveq.w	#27,d2
	moveq.w	#5,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	SetFont	#0
	
	cmp.w	#10,bomblib::score
	bcc		dc_score_greater_ten
		WriteStr	#146,#95,#1,zero
	dc_score_greater_ten:
	cmp.w	#100,bomblib::score
	bcc		dc_score_greater_hundred
		WriteStr	#142,#95,#1,zero
	dc_score_greater_hundred:

	cmp.w	#10,bomblib::scoreh
	bcc		dc_scoreh_greater_ten
		WriteStr	#134,#95,#1,zero
	dc_scoreh_greater_ten:
	cmp.w	#100,bomblib::scoreh
	bcc		dc_scoreh_greater_hundred
		WriteStr	#130,#95,#1,zero
	dc_scoreh_greater_hundred:

	cmp.w	#100,bomblib::score
	bcc		dc_score_isgreater_100
	cmp.w	#0,bomblib::score
	bne		dc_score_is_not_zero
		move.w	bomblib::score,d0
		print_d0	#146,#95,#1
	bra		dc_score_is_end
	dc_score_is_not_zero:
		move.w	bomblib::score,d0
		print_d0	#144,#95,#1
	bra		dc_score_is_end
	dc_score_isgreater_100:
		move.w	bomblib::score,d0
		print_d0	#142,#95,#1
	dc_score_is_end:

	cmp.w	#0,bomblib::scoreh
	bne		dc_scoreh_is_not_zero
	move.w	bomblib::scoreh,d0
	print_d0	#134,#95,#1
	bra		dc_scoreh_is_zero_end
	dc_scoreh_is_not_zero:
	move.w	bomblib::scoreh,d0
	print_d0	#134,#95,#1
	dc_scoreh_is_zero_end:

	SetFont	#1
	rts

;*******************************************Main Loop
;*
;*	The main loop of the program.  Here is how it works:  This loop repeats
;*	itself a very large amount of times.  Every single loop, not every
;*	set of functions get called.  Only if it is time for that to be called.
;*	That is what the t_to_* and def_t_to_* variables represent, the amount
;*	of time until that group of functions is called.  Here are the different
;*	function groups and there respective purposes.
;*
;*	Time counter		Notes
;*	------------		-----
;*	t_to_key		Gets the user's key input and processes it
;*	t_to_handle(bad name)	Moves enemies, handles bombs, extras, explosions...
;*	t_to_collision		Checks various objects if they have collided
;*	t_to_APD		The game speed timer.  This equalizes the game
;*				operations speed.  Very handy.  Heres how it works
;*				Every fraction of a second, on the dot, the 
;*				calculator processor subtracts one from
;*				APD_TIMER.  Each time t_to_APD is equal to zero
;*				in bomber code, the bomber code waits until the
;*				processor decreases APD_TIMER.  In this fashion
;*				we create a VERY exact and reliable game speed
;*				synchronizer tool!
;*
;*********
main_loop:

    	move.w	#0,bomblib::saved_game

		;Handle changes in score since last round
	move.w	bomblib::old_score,d0
	cmp.w	bomblib::score,d0
	beq		no_draw_score
	bsr		draw_score
	no_draw_score:

		;Check game ending countdowns
	cmp.w	#0,bomblib::count_down_flag
	beq		no_count_down
	subq.w	#1,bomblib::count_down_n
	cmp.w	#0,bomblib::count_down_n
	beq		level_break
	no_count_down:

		;Check If all enemies are killed
	cmp.w	#0,bomblib::enemy1count
	beq		enemies_cleared
	end_enemies_cleared:

		;Key input code
	subq.w	#1,t_to_key
	cmp.w	#0,t_to_key
	bne		no_do_key

		move.w	bomblib::def_t_to_key,d0
		move.w	d0,t_to_key

		GetKeyStat #6
		move.b	d0,key2
		GetKeyStat #1
		move.b	d0,key3
		GetKeyStat #0
		move.b	d0,key

		btst.b	#0,key2
		beq	try_end_main_loop
		btst.b	#6,key
		beq	try_timed_bombs
	fail_try_timed_bombs:
		btst.b	#6,key3
		beq	try_power_down
	fail_try_end_main_loop:
	end_power_down:
		cmp.w	#0,bomblib::count_down_flag
		bne		end_keypush
		btst.b	#4,key
		beq	bombdrop
	fail_bombdrop:
		btst.b	#0,key
		beq	keypush
		btst.b	#1,key
		beq	keypush
		btst.b	#2,key
		beq	keypush
		btst.b	#3,key
		beq	keypush

		addq.w	#1,bomblib::time_to_stand
		cmp.w	#3,bomblib::time_to_stand
		beq	redraw
	end_bombdrop:

	end_keypush:

no_do_key:

		;Handle enemies, bombs, explosions, and bonuses
	subq.w	#1,t_to_handle
	cmp.w	#0,t_to_handle
	bne		no_do_handle

		move.w	def_t_to_handle,d0
		move.w	d0,t_to_handle

			move.w	bomblib::bonuscount,d7
			cmp.w	#0,d7
			ble		ml_end_bonus_loop_1
			subq.w	#1,d7
		ml_bonus_loop_1:
			move.w	d7,d6
			bsr	handle_bonus
			dbra.w	d7,ml_bonus_loop_1
		ml_end_bonus_loop_1:

			move.w	bomblib::bexpcount,d7
			cmp.w	#0,d7
			ble		ml_end_bexp_loop_1
			subq.w	#1,d7
		ml_bexp_loop_1:
			move.w	d7,d6
			bsr	handle_bexp
			dbra.w	d7,ml_bexp_loop_1
		ml_end_bexp_loop_1:

			move.w	bomblib::enemy1count,d7
			cmp.w	#0,d7
			ble		ml_end_enemy1_loop_1
			subq.w	#1,d7
		ml_enemy1_loop_1:
			move.w	d7,d6
			jsr	bomblib::learn_enemy1
			bsr	clear_enemy1
			jsr	bomblib::move_enemy1
			bsr	draw_enemy1
			dbra.w	d7,ml_enemy1_loop_1
		ml_end_enemy1_loop_1:

			move.w	bomblib::enemy2count,d7
			cmp.w	#0,d7
			ble		ml_end_enemy2_loop_1
			subq.w	#1,d7
		ml_enemy2_loop_1:
			move.w	d7,d6
			jsr	bomblib::learn_enemy2
			bsr	clear_enemy2
			jsr	bomblib::move_enemy2
			bsr	draw_enemy2
			dbra.w	d7,ml_enemy2_loop_1
		ml_end_enemy2_loop_1:

			move.w	bomblib::bombcount,d7
			cmp.w	#0,d7
			ble		ml_end_bomb_loop_1
			subq.w	#1,d7
		ml_bomb_loop_1:
			move.w	d7,d6
			bsr	handle_bomb
			dbra.w	d7,ml_bomb_loop_1
		ml_end_bomb_loop_1:

		move.w	#0,bombs_are_triggered

			move.w	bomblib::hexpcount,d7
			cmp.w	#0,d7
			ble		ml_end_hexp_loop_1
			subq.w	#1,d7
		ml_hexp_loop_1:
			move.w	d7,d6
			bsr	handle_hexp
			dbra.w	d7,ml_hexp_loop_1
		ml_end_hexp_loop_1:

			move.w	bomblib::vexpcount,d7
			cmp.w	#0,d7
			ble		ml_end_vexp_loop_1
			subq.w	#1,d7
		ml_vexp_loop_1:
			move.w	d7,d6
			bsr	handle_vexp
			dbra.w	d7,ml_vexp_loop_1
		ml_end_vexp_loop_1:

			move.w	bomblib::xexpcount,d7
			cmp.w	#0,d7
			ble		ml_end_xexp_loop_1
			subq.w	#1,d7
		ml_xexp_loop_1:
			move.w	d7,d6
			bsr	handle_xexp
			dbra.w	d7,ml_xexp_loop_1
		ml_end_xexp_loop_1:

		move.w	#4,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#95,d1
		move.w	#122,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz

		bsr		draw_sprite

		bra		ml_did_handle

no_do_handle:

ml_did_handle:

		;Handle collisions
	subq.w	#1,t_to_collision
	cmp.w	#0,t_to_collision
	bne		no_do_collision

		move.w	def_t_to_collision,d0
		move.w	d0,t_to_collision

		bsr		col_me_vs_enemy1
		bsr		col_me_vs_enemy2
		bsr		col_me_vs_hexp
		bsr		col_me_vs_vexp
		bsr		col_me_vs_bonus
		bsr		col_en1_vs_hexp
		bsr		col_en1_vs_vexp
		bsr		col_en2_vs_hexp
		bsr		col_en2_vs_vexp
		end_i_have_died:
no_do_collision:

		;Handle the game speed timer, maintaning constant game speed
	subq.w	#1,t_to_APD
	cmp.w	#0,t_to_APD
	bne		no_do_APD
		move.w	def_t_to_APD,d0
		move.w	d0,t_to_APD
		APD_loop:
		cmp.l	#5,APD_TIMER
		beq	APD_loop
		;cmp.w	#0,APD_FLAG
		;beq	APD_loop
		move.l	#5,APD_TIMER
		clr.w	APD_FLAG
no_do_APD:

	bra main_loop

try_end_main_loop:			;when the esc button is clicked
	btst.b	#0,key
	beq	fail_try_end_main_loop
	bra	exit_game_ask_save

try_power_down:				;turn off calc (Clear button)
	trap #4
	bra	end_power_down

try_timed_bombs:			;if timed bombs are activated (DIMOND)
	cmp.w	#0,bomblib::bombcount
	bne	timed_bombs_hit
	bra	fail_try_timed_bombs

bombdrop:				;player drops a bomb (2nd)
	move.w	bomblib::bombcount,d0
	cmp.w	bomblib::bombsallowed,d0
	beq		fail_bombdrop
	SetPosInfo bomblib::plx,bomblib::ply
	move.w	block_x,d0
	move.w	block_y,d1
	GetBoard d7
	cmp.w	#3,d7
	beq		fail_bombdrop
	move.w	block_x,x
	move.w	block_y,y
	bsr	add_bomb
	bra end_bombdrop

keypush:					;the player wants to move
	move.w	#0,bomblib::time_to_stand
	bsr	movement
	SetPosInfo bomblib::plx,bomblib::ply
	bsr	check_movement
	SetPosInfo bomblib::oldx,bomblib::oldy
	bsr	clear_sprite
	bsr	draw_board_close
	bsr	check_redraw
	bsr	draw_sprite
	move.w	bomblib::plx,bomblib::oldx
	move.w	bomblib::ply,bomblib::oldy
	move.w	bomblib::spritelevel,bomblib::oldspritelevel
	move.w	bomblib::oldmove,bomblib::oldoldmove

	bra	end_keypush

timed_bombs_hit:				;a second check for bomb triggering
	cmp.w	#0,bomblib::trigger_bombs
	beq	end_keypush
	move.w	#1,bombs_are_triggered
	bra	end_keypush

redraw:						;redraw the bomber and surrounding
	move.w	#0,bomblib::time_to_stand	;blocks and whatnot(not the whole
	move.w	#0,bomblib::spritelevel		;board!!!
	bsr	clear_sprite
	bsr	check_redraw
	bsr	draw_sprite
	move.w	bomblib::plx,bomblib::oldx
	move.w	bomblib::ply,bomblib::oldy
	move.w	bomblib::oldmove,bomblib::oldoldmove
	move.w	bomblib::spritelevel,bomblib::oldspritelevel
	bra	end_keypush

;*******************************************I have been killed
;*
;*	I have collided, this starts the time-to-game-ending timer
;*	the game still runs for 100 mainloop revolutions
;*
;********
i_have_died:
	move.w	#1,bomblib::count_down_flag
	move.w	#100,bomblib::count_down_n
	move.w	#1,bomblib::count_down_reason	;one means I have died
	bra		end_i_have_died

;*******************************************Enemies	Cleared
;*
;*	I have killed the enemies, this starts the time-to-game-ending timer
;*	the game still runs for 100 mainloop revolutions
;*
;********
enemies_cleared:
	tst.w	bomblib::count_down_reason
	bne		end_enemies_cleared

	move.w	#1,bomblib::count_down_flag
	move.w	#100,bomblib::count_down_n
	move.w	#2,bomblib::count_down_reason	;2 means enemies killed
	bra		end_enemies_cleared

;*******************************************End of counter
;*
;*	The game time-to-ending counter has gone from 100 to 0
;*	The game has now really ended
;*
;********
level_break:
	cmp.w	#1,bomblib::count_down_reason
	beq		level_break_death

	cmp.w	#2,bomblib::count_down_reason
	beq		level_break_enemy_cleared

	move.w	#0,bomblib::count_down_reason
	move.w	#0,bomblib::count_down_flag
	bra		main_loop		;not a valid reason

level_break_death:
	cmp.w	#0,bomblib::pllife
	beq		call_check_high_score
	subq.w	#1,bomblib::pllife
	bra		restart_game

level_break_enemy_cleared:
	cmp.w	#0,bomblib::enemy1count
	bne		end_enemies_cleared
	cmp.w	#0,bomblib::level
	beq		call_check_high_score

	cmp.w	#15,bomblib::level
	beq		call_check_high_score

	addq.w	#1,bomblib::level
	cmp.w	#4,bomblib::level
	beq		add_difficulty
	cmp.w	#7,bomblib::level
	beq		add_difficulty
	cmp.w	#10,bomblib::level
	beq		add_difficulty
	cmp.w	#13,bomblib::level
	beq		add_difficulty
	bra		restart_game

add_difficulty:					;go to next level, 
						;increase difficulty
	addq.w	#1,bomblib::game_difficulty
	bra		restart_game

call_check_high_score:					;is over man!!!
	jsr		bomblib::check_high_score
	bra		startup

;*******************************************INT1 OPERATIONS
;*
;*	This code makes direct keyboard memory aquisition better.  It doesn't
;*	work with grayscale though so was never used!
;*
;********
enable_int1:
	move.w 		#$0700,d0		;\ disable interrupts, and put
	trap   		#1			;/ the old int mask in D0
	bclr.b 		#2,$600001		; disable protection of memory
	move.l 		oldint_addr,$64
	bset.b 		#2,$600001		; re-enable protection of memory
	trap   		#1			; restore the old interrupt mask
	rts

disable_int1:
	move.w 		#$0700,d0               ;\ disable interrupts, and put
	trap   		#1                      ;/ the old int mask in D0
	bclr.b 		#2,$600001              ; disable protection of memory
	move.l 		($64),oldint_addr	; retrieve the value of address $64
	move.l 		#n_aint1,($64)		; put nothing in the int1 handler matrix
	bset.b 		#2,$600001              ; re-enable protection of memory
	trap   		#1                      ; restore the old interrupt mask
	rts

n_aint1:
        rte

oldint_addr:
	dc.l 0

;*******************************CONVERT D0 TO A STRING
;*
;*	This is used for print_d0 macro and serves no other purpose!
;*
;******
ConvStr:
    movem.l d0-d2,-(a7)
    clr.b   (a0)
conv_repeat:
    divu    #10,d0
    move.l  d0,d2
    swap    d2
    add.b   #48,d2
    move.b  d2,-(a0)
    subq    #1,d1
    and.l   #$FFFF,d0
    bne     conv_repeat
    tst.w   d1
    beq     conv_done
    subq    #1,d1
fillout:
    move.b  #32,-(a0)
    dbra    d1,fillout
conv_done:
    movem.l (a7)+,d0-d2
    rts

str             ds.b 16
strend

	include "sprites.asm"		;includes the sprites for almost everything

;*******************************************Comment

_comment   dc.b    "BomberBoy v.45b",0
        end
