;*******************************************Clear Enemy
;*
;*	Clear the screen where the enemy1 lies
;*
;*	Input:	d0=x coordinate in pixels
;*		d1=y coordinate in pixels
;*
;********
clear_enemy1:
	move.w	(a2),d0
	move.w	(a3),d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	rts

;*******************************************Draw Enemy
;*
;*	Draws the enemy1 sprite
;*
;*	Input:	a2=points to x-coordinate in array
;*		a3=points to y-coordinate in array
;*		a4=points to current sprite information
;*
;********
draw_enemy1:
	move.w	(a2),d2
	move.w	(a3),d3
	move.w	(a4),d4
	cmp.w	#0,d4
	beq		de1_s1
	cmp.w	#1,d4
	beq		de1_s2
	cmp.w	#2,d4
	beq		de1_s3
	cmp.w	#3,d4
	beq		de1_s2
	rts

de1_s1:
	PutGray4Sprite sprite_enemy110,sprite_enemy111,d2,d3
	rts

de1_s2:
	PutGray4Sprite sprite_enemy120,sprite_enemy121,d2,d3
	rts

de1_s3:
	PutGray4Sprite sprite_enemy130,sprite_enemy131,d2,d3
	rts

;*******************************************Add Enemy1
;*
;*	Add a new enemy1
;*
;*	Input:	x=x-coordinate of new enemy1 in blocks
;*		y=y-coordinate of new enemy1 in blocks
;*		dir=the direction that the enemy1 will start out pointing towards
;*
;********
add_enemy1:
	movem.l	d0-d2/a0,-(a7)

	lea	bomblib::enemy1_x,a0		;Set vexp x
	move.w  bomblib::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::enemy1_y,a0		;Set vexp y
	move.w  bomblib::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::enemy1_d,a0		;Set vexp s
	move.w  bomblib::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	dir,(a0)

	lea	bomblib::enemy1_s,a0		;Set vexp s
	move.w  bomblib::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	#1,(a0)

	addq.w	#1,bomblib::enemy1count

	movem.l	(a7)+,d0-d2/a0
	rts