;*******************************************Clear Enemy2
;*
;*	Clear the screen where the enemy2 lies
;*
;*	Input:	d0=x coordinate in pixels
;*		d1=y coordinate in pixels
;*
;********
clear_enemy2:
	move.w	(a2),d0
	move.w	(a3),d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	rts

;*******************************************Draw Enemy2
;*
;*	Draws the enemy2 sprite
;*
;*	Input:	a2=points to x-coordinate in array
;*		a3=points to y-coordinate in array
;*		a4=points to current sprite information
;*
;********
draw_enemy2:
	move.w	(a2),d2
	move.w	(a3),d3
	move.w	(a4),d4
	cmp.w	#0,d4
	beq		den2_s1
	cmp.w	#1,d4
	beq		den2_s2
	cmp.w	#2,d4
	beq		den2_s3
	rts

den2_s1:
	PutGray4Sprite sprite_enemy210,sprite_enemy211,d2,d3
	rts

den2_s2:
	PutGray4Sprite sprite_enemy220,sprite_enemy221,d2,d3
	rts

den2_s3:
	PutGray4Sprite sprite_enemy230,sprite_enemy231,d2,d3
	rts

;*******************************************Add Enemy2
;*
;*	Add a new enemy2
;*
;*	Input:	x=x-coordinate of new enemy2 in blocks
;*		y=y-coordinate of new enemy2 in blocks
;*		dir=the direction that the enemy2 will start out pointing towards
;*
;********
add_enemy2:
	movem.l	d0-d2/a0,-(a7)

	lea	bomblib::enemy2_x,a0		;Set vexp x
	move.w  bomblib::enemy2count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::enemy2_y,a0		;Set vexp y
	move.w  bomblib::enemy2count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::enemy2_d,a0		;Set vexp s
	move.w  bomblib::enemy2count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	dir,(a0)

	lea	bomblib::enemy2_s,a0		;Set vexp s
	move.w  bomblib::enemy2count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	#1,(a0)

	addq.w	#1,bomblib::enemy2count

	movem.l	(a7)+,d0-d2/a0
	rts