;*******************************************Handle Horizontal Explosion
;*
;*	This functions handles a horizontal explosion(looks like a -)
;*
;*	Input	d6=the hexp explosion # in the array
;*
;*********
handle_hexp:

	lea	bomblib::hexp_x,a0		;Get hexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomblib::hexp_y,a0		;Get hexp d6's y
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a3

	lea	bomblib::hexp_s,a0		;Get hexp d6's s
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a4

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s

	;cmp.w	#0,s
	;beq		delete_hexp
	;cmp.w	#5,s
	;bhi		delete_hexp

	move.w	x,d0			;clear the screen under the hexp
	move.w	y,d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_hexp

	;move.w	x,(a2)
	;move.w	y,(a3)
	move.w	s,(a4)

		;this code draws the sprite
	cmp.w	#1,s
	beq		hhe_s2
	cmp.w	#2,s
	beq		hhe_s3
	cmp.w	#3,s
	beq		hhe_s4
	cmp.w	#4,s
	beq		hhe_s3
	cmp.w	#5,s
	beq		hhe_s2
	bra		delete_hexp
hhe_exit:
	rts

hhe_s2:
	PutGray4Sprite sprite_hexp20,sprite_hexp21,x,y
	rts

hhe_s3:
	PutGray4Sprite sprite_hexp30,sprite_hexp31,x,y
	rts

hhe_s4:
	PutGray4Sprite sprite_hexp40,sprite_hexp41,x,y
	rts

;*******************************************Delete Horizontal Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the hexp array
;*
;*********
delete_hexp:

	movem.l	d0/a0-a2,-(a7)

	move.w	eblock_x,d0
	move.w	eblock_y,d1
	SetBoard	#0

	lea	bomblib::hexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomblib::hexp_y,a1
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a1,d0.w),a1

	lea	bomblib::hexp_s,a2
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	move.w	bomblib::hexpcount,d0
	sub.w	d6,d0
	cmp.w	#0,d0
	beq		dhe_loop_exit
	subq.w	#1,d0

		;this code shifts the data in the array
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
dhe_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2

	dbra.w	d0,dhe_loop

dhe_loop_exit:
	subq.w	#1,bomblib::hexpcount

	movem.l	(a7)+,d0/a0-a2
	rts

;*******************************************Add Horizontal Explosion
;*
;*	This functions adds an horiz. explosion to the hexp array
;*
;*	Input:	x=x coordinate(in squares) of the new hexp
;*		y=y coordinate(in squares) of the new hexp
;*
;*********
add_hexp:
	movem.l	d0-d4/a0,-(a7)

	move.w	x,d0
	move.w	y,d1
	GetBoard d2
	SetBoard #0
	cmp.w	#3,d2
	bne		add_hexp_no_bomb

	mulu.w	#9,d0
	addq.w	#5,d0
	mulu.w	#9,d1
	addq.w	#5,d1

				;this code looks for a bomb under this explosion
				;wherein it will explode it
			move.w	bomblib::bombcount,d4
			cmp.w	#0,d4
			ble		add_hexp_end_bomb_loop_1
			subq.w	#1,d4
		add_hexp_bomb_loop_1:
			move.w	d4,d3

			lea	bomblib::bomb_x,a0		;Set hexp x
			mulu.w	#2,d3
			lea	0(a0,d3.w),a0
			move.w	(a0),d2

			cmp.w	d2,d0
			bne		add_hexp_bomb_nope

				lea	bomblib::bomb_y,a0		;Set hexp y
				lea	0(a0,d3.w),a0
				move.w	(a0),d2

				cmp.w	d2,d1
				bne		add_hexp_bomb_nope

					lea	bomblib::bomb_es,a0		;Set hexp es
					lea	0(a0,d3.w),a0
					move.w	#1,(a0)

			add_hexp_bomb_nope:

			dbra.w	d4,add_hexp_bomb_loop_1
		add_hexp_end_bomb_loop_1:
		bra	cancel_add_hexp
add_hexp_no_bomb:

	lea	bomblib::hexp_x,a0		;Set hexp x
	move.w  bomblib::hexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::hexp_y,a0		;Set hexp y
	move.w  bomblib::hexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::hexp_s,a0		;Set hexp s
	move.w  bomblib::hexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomblib::explife,(a0)

	addq.w	#1,bomblib::hexpcount

cancel_add_hexp:
	movem.l	(a7)+,d0-d4/a0
	rts