;*******************************************Handle Verticle Explosion
;*
;*	This functions handles an vertical explosion(looks like |)
;*
;*	Input	d6=the vexp explosion # in the array
;*
;*********
handle_vexp:

	lea	bomblib::vexp_x,a0		;Get vexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomblib::vexp_y,a0		;Get vexp d6's y
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a3

	lea	bomblib::vexp_s,a0		;Get vexp d6's s
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a4

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s

	move.w	x,d0			;clear the screen for its location
	move.w	y,d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	cmp.w	#0,s
	beq		delete_vexp
	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_vexp

	;move.w	x,(a2)
	;move.w	y,(a3)
	move.w	s,(a4)

		;draw the vexp sprite
	cmp.w	#1,s
	beq		hve_s2
	cmp.w	#2,s
	beq		hve_s3
	cmp.w	#3,s
	beq		hve_s4
	cmp.w	#4,s
	beq		hve_s3
	cmp.w	#5,s
	beq		hve_s2
	bra		delete_vexp
	rts

hve_s2:
	PutGray4Sprite sprite_vexp20,sprite_vexp21,x,y
	rts

hve_s3:
	PutGray4Sprite sprite_vexp30,sprite_vexp31,x,y
	rts

hve_s4:
	PutGray4Sprite sprite_vexp40,sprite_vexp41,x,y
	rts

;*******************************************Delete Verticle Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the vexp array
;*
;*********
delete_vexp:

	movem.l	d0/a0-a2,-(a7)

	move.w	eblock_x,d0
	move.w	eblock_y,d1
	SetBoard	#0

	lea	bomblib::vexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomblib::vexp_y,a1
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a1,d0.w),a1

	lea	bomblib::vexp_s,a2
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	move.w	bomblib::vexpcount,d0
	sub.w	d6,d0
	cmp.w	#0,d0
	beq		dve_loop_exit
	subq.w	#1,d0

		;this code shifts the array one less starting at the posiion of this sprite
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
dve_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2

	dbra.w	d0,dve_loop

dve_loop_exit:
	subq.w	#1,bomblib::vexpcount

	movem.l	(a7)+,d0/a0-a2
	rts

;*******************************************Add Verticle Explosion
;*
;*	This functions adds a verticle explosion to the vexp array
;*
;*	Input:	x=x coordinate(in squares) of the new vexp
;*		y=y coordinate(in squares) of the new vexp
;*
;*********
add_vexp:
	movem.l	d0-d4/a0,-(a7)

	move.w	x,d0
	move.w	y,d1
	GetBoard d2
	SetBoard #0
	cmp.w	#3,d2
	bne		add_vexp_no_bomb

	mulu.w	#9,d0
	addq.w	#5,d0
	mulu.w	#9,d1
	addq.w	#5,d1

				;this code checks if this explosion
				;occurs on top of a bomb, wherein
				;it will set the bomb off
			move.w	bomblib::bombcount,d4
			cmp.w	#0,d4
			ble		add_vexp_end_bomb_loop_1
			subq.w	#1,d4
		add_vexp_bomb_loop_1:
			move.w	d4,d3

			lea	bomblib::bomb_x,a0		;Set vexp x
			mulu.w	#2,d3
			lea	0(a0,d3.w),a0
			move.w	(a0),d2

			cmp.w	d2,d0
			bne		add_vexp_bomb_nope

				lea	bomblib::bomb_y,a0		;Set vexp y
				lea	0(a0,d3.w),a0
				move.w	(a0),d2

				cmp.w	d2,d1
				bne		add_vexp_bomb_nope

					lea	bomblib::bomb_es,a0		;Set vexp es
					lea	0(a0,d3.w),a0
					move.w	#1,(a0)

			add_vexp_bomb_nope:

			dbra.w	d4,add_vexp_bomb_loop_1
		add_vexp_end_bomb_loop_1:
		bra	cancel_add_vexp

add_vexp_no_bomb:

	lea	bomblib::vexp_x,a0		;Set vexp x
	move.w  bomblib::vexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::vexp_y,a0		;Set vexp y
	move.w  bomblib::vexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::vexp_s,a0		;Set vexp s
	move.w  bomblib::vexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomblib::explife,(a0)

	addq.w	#1,bomblib::vexpcount

cancel_add_vexp:
	movem.l	(a7)+,d0-d4/a0
	rts
